<html>
<head>
	<title>Aero-Sharp Monitor</title>
	<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1.2">
	<style type="text/css">
		body { font-family: arial; }
		.itemListing { background-color: #eee; }
		.itemListing .heading { font-weight: bold; background-color: #ccc; }
		.itemListing .alternate { background-color: #ddd; }
	</style>
</head>
<body>

<h3>Aero-Sharp Web Monitor</h3><?php
$invRtnStr = get_aerosharp_status_from_port();
$aeroSharpStatusInfo = analyse_aerosharp_status_data($invRtnStr);
display_aerosharp_status($aeroSharpStatusInfo);
?>
<br />
<a href="<?php echo $_SERVER[PHP_SELF]?>">[Refresh]</a>
<br />

<script type="text/javascript">
 if(navigator.userAgent.match(/Android/i)){
    //window.scrollTo(0,1);
 }
</script>
</body>
</html>
<?php

/////////////////////////////////////

function get_aerosharp_status_from_port(){
	$serProxyHost = "127.0.0.1";
	$serProxyPort = 5331;
	$timeout = 5;
	$cmdText = hex2bin("AA0502000000020000"); //string to send to the inverter to get it to send back status data
	$fp = fsockopen ($serProxyHost, $serProxyPort, $errno, $errstr, $timeout);
	if (!$fp) {
		echo "$errstr ($errno)";
	} else {
		fputs ($fp, $cmdText);
		usleep(100000); //pause for a couple of hundred milliseconds to wait for inverter to send output
		$output  = fread($fp,34);
		fclose ($fp);
		$invRtnStr = bin2hex($output);	//turn binary data into hex string
		if($invRtnStr=="") return false;
		return $invRtnStr;		
	}
}

function analyse_aerosharp_status_data($inverterStatusString){
	if($inverterStatusString=="" || $inverterStatusString===false) {
		echo "Invalid data or no data returned. Check port settings and try again. Inverter could be shut down for the night.<br />";
		return false;
	}
	$binData = hex2bin($inverterStatusString);
	$aeroSharpStatusInfo[acfreq] = bin2asc ( combine_left_all(substr($binData,6,1),substr($binData,4,1)) ) / 10 ;
	$aeroSharpStatusInfo[acvolt] = bin2asc ( combine_right_all(substr($binData,6,1), substr($binData,5,1)) ) / 10  ;
	$aeroSharpStatusInfo[acamps] = bin2asc ( substr($binData,7,1) ) /10;
	$aeroSharpStatusInfo[acwatt] = bin2asc ( substr($binData,16,2) ) /10;
	$aeroSharpStatusInfo[pv1volt] = bin2asc ( substr($binData,10,2) ) /10;
	$aeroSharpStatusInfo[pv1amps] = bin2asc ( substr($binData,12,1) ) /10;
	$aeroSharpStatusInfo[pv2volt] = bin2asc ( substr($binData,13,2) ) /10;
	$aeroSharpStatusInfo[pv2amps] = bin2asc ( substr($binData,14,1) ) /10;
	$aeroSharpStatusInfo[temperature] = bin2asc ( substr($binData,18,1) );
	$aeroSharpStatusInfo[etoday] = bin2asc ( substr($binData,21,2) ) / 10;
	$aeroSharpStatusInfo[etotal] = bin2asc ( substr($binData,23,3) );	
	$aeroSharpStatusInfo[timetoday] = bin2asc ( substr($binData,27,1) ) / 10;
	$aeroSharpStatusInfo[timetotal] = bin2asc ( substr($binData,28,3) );
	$aeroSharpStatusInfo[test] = bin2asc ( substr($binData,32,1) );
	$aeroSharpStatusInfo[test2] = bin2asc ( substr($binData,19,1) );
	$aeroSharpStatusInfo[test3] = bin2asc ( substr($binData,20,1) );
	if(bin2asc ( substr($binData,19,1) ) == 1) $aeroSharpStatusInfo[status] = "Stand By";
	if(bin2asc ( substr($binData,19,1) ) == 136) $aeroSharpStatusInfo[status] = "Max. P.P.";
	if(bin2asc ( substr($binData,20,1) ) == 2) $aeroSharpStatusInfo[status] = "Grid Volt Error";
	return $aeroSharpStatusInfo;
}

function display_aerosharp_status($aeroSharpStatusInfo){
	?>
	<table class="itemListing" border="1" cellspacing="0" cellpadding="3">
		<tr class="heading"><td>Parameter</td>		<td>Value</td>	<td>Unit</td></tr>
		<tr class="alternat_"><td>AC Frequency</td>	<td style="text-align: right;"><?php echo number_format($aeroSharpStatusInfo[acfreq],1)?></td>	<td>Hz</td>
		<tr class="alternat_"><td>AC Voltage</td>	<td style="text-align: right;"><?php echo number_format($aeroSharpStatusInfo[acvolt],1)?></td>	<td>Volt</td>
		<tr class="alternate"><td>AC Wattage</td>	<td style="text-align: right;"><?php echo number_format($aeroSharpStatusInfo[acwatt],1)?></td>	<td>Watt</td>
		<tr class="alternate"><td>AC Current</td>	<td style="text-align: right;"><?php echo number_format($aeroSharpStatusInfo[acamps],1)?></td>	<td>Amp</td>
		<tr class="alternat_"><td>PV1 Voltage</td>	<td style="text-align: right;"><?php echo number_format($aeroSharpStatusInfo[pv1volt],1)?></td>	<td>Volt</td>
		<tr class="alternat_"><td>PV1 Current</td>	<td style="text-align: right;"><?php echo number_format($aeroSharpStatusInfo[pv1amps],1)?></td>	<td>Amp</td>
		<tr class="alternate"><td>Energy Today</td>	<td style="text-align: right;"><?php echo number_format($aeroSharpStatusInfo[etoday],1)?></td>	<td>kWh</td>
		<tr class="alternate"><td>Energy Total</td>	<td style="text-align: right;"><?php echo number_format($aeroSharpStatusInfo[etotal])?></td>	<td>kWh</td>		
		<tr class="alternat_"><td>Time Today</td>	<td style="text-align: right;"><?php echo number_format($aeroSharpStatusInfo[timetoday],1)?></td><td>Hours</td>
		<tr class="alternat_"><td>Time Total</td>	<td style="text-align: right;"><?php echo number_format($aeroSharpStatusInfo[timetotal])?></td><td>Hours</td>
		<tr class="alternate"><td>Temperature</td>	<td style="text-align: right;"><?php echo $aeroSharpStatusInfo[temperature]?></td>		<td><sup>o</sup>C</td>			
		<tr class="alternate"><td>Status/Mode</td>	<td colspan="2" style="text-align: right;"><?php echo $aeroSharpStatusInfo[status]?></td>			
	</table>
	<?php
}

function combine_left_all($left_byte, $right_byte) { // lets get the left part of left_byte and ALL of right_byte and join em
  //$combined = $left_byte << 4 | $right_byte;
  $combined = hex2bin( bin2hex($right_byte) . substr(bin2hex($left_byte),0,1) );
  return $combined ;
}
function combine_right_all($left_byte, $right_byte) { // lets get the right part of left_byte and ALL of right_byte and join em
  //$combined = ($left_byte & 0xF) << 8  | $right_byte;
  $combined = hex2bin(bin2hex($right_byte) . substr(bin2hex($left_byte),-1,1) );
  return $combined;
}
function hex2bin($data){
	$bin    = "";
	$i      = 0;
	do {
		$bin    .= chr(hexdec($data{$i}.$data{($i + 1)}));
		$i      += 2;
	} while ($i < strlen($data));
	return $bin;
}
function bin2asc ($binary){
//--------------------- Convert raw ASCII binary data to decimal-------------
   $val = 0;
   for ($i = strlen($binary) - 1; $i >= 0; $i--) {
       $ch = substr($binary, $i, 1);
       $val = ($val << 8) | ord($ch);
   }
   return $val;
}

?>